{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

uses SysUtils, Math;

const MaxN = 3000+1;

var
  a: array[1..MaxN] of integer;
  i, l, r, res, kout, kans, t: integer;
  AllBad: boolean;
  s: string;
  fin, fout, fans: text;

procedure Ex(const s: string; ec: integer);
begin
  write(s);
  try
    close(fin); close(fout); close(fans);
  except
  end;
  halt(ec);
end;

procedure inv(var c: char);
begin
  if c = ')' then c := '(' else c := ')';
end;

begin
  try
    assign(fin,paramstr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    assign(fans,paramstr(3)); reset(fans);
  except on e: Exception do
    Ex('Error opening answer: ' + e.Message, 3);
  end;
  try
    assign(fout,paramstr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  try
    read(fin, s);
  except on e: Exception do
    Ex('Invalid input: ' + e.Message, 3);
  end;
   try
    read(fans, kans);
  except on e: Exception do
    Ex('Invalid answer: ' + e.Message, 3);
  end;
  try
    if SeekEOF(fout) then
      Ex('There''s no data in output', 2);
    read(fout, kout);
    if (kout < 0) then
      if (kout = kans) then
        Ex('ok', 0)
      else
        Ex('Wrong operation quantity: '+IntToStr(kout)+ ' instead of '+IntToStr(kans), 1);
    FillChar(a, SizeOf(a), 0);
    for i := 1 to kout do
      begin
        AllBad := false;
        if SeekEOF(fout) then AllBad := true;
        read(fout, l);
        if SeekEOF(fout) then AllBad := true;
        read(fout, r);
        if AllBad then
          begin
            Ex('There''s no pair #'+IntToStr(i), 2)
          end
        else
          begin
            if (l < 1) or (l > length(s)) or (r < 1) or (r > length(s)) or (r < l) then
              Ex(format('Invalid pair #%d: (left:%d right:%d), string length is %d', [i, l, r, length(s)]), 2);
            inc(a[l]); inc(a[r+1]);
          end;
      end;
    if not SeekEOF(fout) then Ex('There''s extra data in output', 2);
  except on e: Exception do
    Ex(e.Message, 2);
  end;
  res := 0; t := 0;
  l := length(s);
  for i := 1 to l do
    begin
      inc(t, a[i]);
      if t and 1 = 1 then inv(s[i]);
      if s[i] = ')' then
        dec(res)
      else
        inc(res);
      if res < 0 then Ex('Incorrect bracket sequence: too many closing brackets', 1);
    end;
//  writeln(s);
  if s[l] <> ')' then Ex('Incorrect bracket sequence: last character is not '')''', 1);
  if res > 0 then Ex('Incorrect bracket sequence: too many opening brackets', 1);
  if kout > kans then Ex('Wrong operation quantity: '+IntToStr(kout)+ ' instead of '+IntToStr(kans), 1);
  if kout < kans then Ex('Output is better then answer', 3);
  Ex('ok', 0);
end.