{$MODE OBJFPC}
{$H+}

uses SysUtils;

const MaxLen = 3000;

var matrix: array[0..MaxLen, 0..MaxLen, 0..1] of integer;
    p: array[1..MaxLen] of integer;
    i, j, k, cnt, len, CurrAns, ans, r: integer;
    s: string;
    fi, fo: text;

begin
  FillChar(matrix, SizeOf(matrix), $FF);
  FillChar(matrix[0, 0, 0], SizeOf(matrix[0, 0, 0]), 0);
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  read(fi, s); len := length(s); 
  assert(len <= MaxLen, 'Input string length is more than possible');
  for i := 1 to len do
    begin
      assert(s[i] in ['(', ')'], format('Invalid character ''%s''(code: %d) in %d position', [s[i], ord(s[i]), i]));
      if s[i] = ')' then p[i] := -1 else p[i] := 1;
    end;
  for i := 0 to len - 1 do
    begin
      for j := 0 to len - i do
        begin
          for k := 0 to 1 do
            begin
              CurrAns := matrix[i, j, k]; 
              if CurrAns = -1 then continue;
              if k = 0 then cnt := j+p[i+1] else cnt := j-p[i+1];
              if (cnt >= 0) and ((matrix[i+1, cnt, k] > matrix[i, j, k]) or
              (matrix[i+1, cnt, k] = -1)) then
                matrix[i+1, cnt, k] := matrix[i, j, k];
              if k = 1 then cnt := j+p[i+1] else cnt := j-p[i+1];
              if (cnt >= 0) and ((matrix[i+1, cnt, 1-k] > matrix[i, j, k]+ord(k=0)) or
              (matrix[i+1, cnt, 1-k] = -1)) then
                begin
                  matrix[i+1, cnt, 1-k] := matrix[i, j, k];
                  if k = 0 then inc(matrix[i+1, cnt, 1-k]);
                end;
            end;
        end;
    end;
  if len and 1 = 1 then
    begin
      write(fo, -1);
    end
  else
    begin
      if (matrix[len, 0, 1] < matrix[len, 0, 0]) and
        (matrix[len, 0, 1] <> -1) or (matrix[len, 0, 0] = -1) then
        begin
          k := 1;
          r := len;
        end
      else
        begin
          k := 0;
        end;
      j := 0;
      ans := matrix[len, 0, k];
      writeln(fo, ans);
      FillChar(matrix[0, 0], SizeOf(matrix[0, 0]), 0);
      for i := len downto 2 do
        begin
          if k = 0 then
            begin
              if matrix[i, j, k] = matrix[i-1, j-p[i], k] then
                begin
                  dec(j, p[i]);
                end
              else
                begin
                  r := i-1;
                  dec(j, p[i]);
                  k := 1;
                end;
            end
          else
            begin
              if matrix[i, j, k] = matrix[i-1, j+p[i], k] then
                begin
                  inc(j, p[i]);
                end
              else
                begin
                  writeln(fo, i, ' ', r);
                  inc(j, p[i]);
                  k := 0;
                end;
            end;
        end;
      if k = 1 then
        writeln(fo, 1, ' ', r);
    end;
  CloseFile(fi);
  CloseFile(fo);
end.